=== binr/rarun2/Makefile ===
BIN=rarun2
BINDEPS=r_socket r_util

include ../rules.mk
include ../../libr/socket/deps.mk
