=== debian/changelog ===
radare2 (2.3.0+dfsg-2) unstable; urgency=medium

  * Add missing libcapstone-dev dependency to libradare2-dev
  * Fix Vcs urls

 -- Sebastian Reichel <sre@debian.org>  Fri, 23 Feb 2018 11:38:59 +0100

radare2 (2.3.0+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Switch to package maintence from alioth to salsa
  * Make package team-maintained under pkg-security-team umbrella
  * Update Debian Standards Version to 4.1.3
  * Fix priority-extra-is-replaced-by-priority-optional
  * Update debian/copyright, debian/watch to use native support
    for cleaning up the orig tarball and drop the get-orig-source
    target from debian/rules.

 -- Sebastian Reichel <sre@debian.org>  Wed, 14 Feb 2018 17:48:06 +0100
