=== debian/rules ===
#!/usr/bin/make -f
DEB_DEBIAN_DIR=$(dir $(firstword $(MAKEFILE_LIST)))

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEBUG_SUPPORT=0
EXTRA_FLAGS=--with-sysmagic --with-syszip --with-syscapstone --with-libversion=2.3

DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

ifeq (arm,$(DEB_HOST_ARCH_CPU))
DEBUG_SUPPORT=1
endif

# currently broken
#ifeq (arm64,$(DEB_HOST_ARCH_CPU))
#DEBUG_SUPPORT=1
#endif

ifeq (i386,$(DEB_HOST_ARCH_CPU))
DEBUG_SUPPORT=1
endif

ifeq (amd64,$(DEB_HOST_ARCH_CPU))
DEBUG_SUPPORT=1
endif

ifeq (mips,$(DEB_HOST_ARCH_CPU))
DEBUG_SUPPORT=1
endif

ifeq (mips64,$(DEB_HOST_ARCH_CPU))
DEBUG_SUPPORT=1
endif

ifeq (powerpc,$(DEB_HOST_ARCH_CPU))
DEBUG_SUPPORT=1
endif

ifeq (ppc64,$(DEB_HOST_ARCH_CPU))
DEBUG_SUPPORT=1
endif

ifneq (linux,$(DEB_HOST_ARCH_OS))
DEBUG_SUPPORT=0
endif

ifeq (0,$(DEBUG_SUPPORT))
EXTRA_FLAGS+=--disable-debugger
endif

%:
	dh $@

override_dh_auto_configure:
	./configure --prefix=/usr --libdir=/usr/lib/$(DEB_HOST_MULTIARCH) ${EXTRA_FLAGS}
	# add version to soname
	echo "HAVE_LIBVERSION=1" >> config-user.mk

override_dh_makeshlibs:
	dh_makeshlibs --exclude=/usr/lib/$(DEB_HOST_MULTIARCH)/radare2/

override_dh_auto_install:
	dh_auto_install
	# No need to install Makefile
	rm debian/tmp/usr/share/radare2/last/cons/Makefile
	# remove "last" symlink
	rm debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/radare2/last
	rm debian/tmp/usr/share/radare2/last
	# remove useless license file
	rm debian/tmp/usr/share/doc/radare2/license
	# install zsh completion files
	mkdir -p debian/tmp/usr/share/zsh/vendor-completions
	install -m 644 doc/zsh/_* debian/tmp/usr/share/zsh/vendor-completions

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_clean:
	touch config-user.mk libr/config.mk
	-dh_auto_clean
	rm -f config-user.mk libr/config.mk
