## radare2 2.4.0+dfsg

=== debian/changelog ===
radare2 (2.4.0+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Sebastian Reichel <sre@debian.org>  Mon, 05 Mar 2018 21:32:57 +0100
