=== debian/control ===
--- 
+++ 
@@ -40,7 +40,7 @@
  supporting PE, mach0, ELF, class, etc. named rabin, and a block-based
  hash utility called rahash.
 
-Package: libradare2-2.3
+Package: libradare2-2.4
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
@@ -64,7 +64,7 @@
 Package: libradare2-dev
 Section: libdevel
 Architecture: any
-Depends: ${misc:Depends}, libradare2-2.3 (= ${binary:Version}),
+Depends: ${misc:Depends}, libradare2-2.4 (= ${binary:Version}),
          libcapstone-dev, libmagic-dev
 Description: devel files from the radare2 suite
  The project aims to create a complete, portable, multi-architecture,
