=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 DEBUG_SUPPORT=0
-EXTRA_FLAGS=--with-sysmagic --with-syszip --with-syscapstone --with-libversion=2.3
+EXTRA_FLAGS=--with-sysmagic --with-syszip --with-syscapstone --with-libversion=2.4
 
 DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
 DPKG_EXPORT_BUILDFLAGS = 1
@@ -69,7 +69,7 @@
 	rm debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/radare2/last
 	rm debian/tmp/usr/share/radare2/last
 	# remove useless license file
-	rm debian/tmp/usr/share/doc/radare2/license
+	rm debian/tmp/usr/share/doc/radare2/license.md
 	# install zsh completion files
 	mkdir -p debian/tmp/usr/share/zsh/vendor-completions
 	install -m 644 doc/zsh/_* debian/tmp/usr/share/zsh/vendor-completions
